Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistInput.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistInput.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistInput.cs	(revision 9392)
@@ -0,0 +1,30 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IGAssistInput : IItem {
+    IEnumerable<string> VariableNames { get; }
+    string GetVariableValue(string variableName);
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistSolution.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistSolution.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IGAssistSolution.cs	(revision 9392)
@@ -0,0 +1,33 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IGAssistSolution : IItem {
+    double TrainingAccuracy { get; }
+    double TestAccuracy { get; }
+    int TrainingNumberOfAliveRules { get; }
+    double TrainingTheoryLength { get; }
+    double TrainingExceptionsLength { get; }
+    int Classes { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IStrataSingleObjectiveEvaluator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IStrataSingleObjectiveEvaluator.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/Interfaces/IStrataSingleObjectiveEvaluator.cs	(revision 9392)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IStrataSingleObjectiveEvaluator : ISingleObjectiveEvaluator {
+    ILookupParameter<ItemList<ItemList<IntValue>>> StrataParameter { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/BestSolutionCreator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/BestSolutionCreator.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/BestSolutionCreator.cs	(revision 9392)
@@ -0,0 +1,71 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  [Item("BestSolutionCreator", "Description missing")]
+  [StorableClass]
+  public class BestSolutionCreator : SingleSuccessorOperator {
+
+    #region Parameter Properties
+    public IValueLookupParameter<IGAssistSolution> SolutionParameter {
+      get { return (IValueLookupParameter<IGAssistSolution>)Parameters["Solution"]; }
+    }
+    public ScopeTreeLookupParameter<IGAssistIndividual> IndividualParameter {
+      get { return (ScopeTreeLookupParameter<IGAssistIndividual>)Parameters["Individual"]; }
+    }
+    public LookupParameter<IGAssistNichesProblemData> ProblemDataParameter {
+      get { return (LookupParameter<IGAssistNichesProblemData>)Parameters["ProblemData"]; }
+    }
+    public IScopeTreeLookupParameter<DoubleValue> QualityParameter {
+      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public ILookupParameter<BoolValue> MaximizationParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected BestSolutionCreator(bool deserializing) : base(deserializing) { }
+    public BestSolutionCreator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<IGAssistIndividual>("Solution", ""));
+      Parameters.Add(new ScopeTreeLookupParameter<IGAssistIndividual>("Individual", ""));
+      Parameters.Add(new LookupParameter<IGAssistNichesProblemData>("ProblemData", ""));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the trees that should be analyzed."));
+      Parameters.Add(new LookupParameter<BoolValue>("Maximization", "The direction of optimization."));
+    }
+
+    public override IOperation Apply() {
+      var qualities = QualityParameter.ActualValue;
+      var bestQuality = MaximizationParameter.ActualValue.Value ? qualities.Max() : qualities.Min();
+      int index = qualities.IndexOf(bestQuality);
+      SolutionParameter.ActualValue = IndividualParameter.ActualValue[index].CreateGAssistSolution(ProblemDataParameter.ActualValue);
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/IMDLCalculatorBasedOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/IMDLCalculatorBasedOperator.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/IMDLCalculatorBasedOperator.cs	(revision 9392)
@@ -0,0 +1,28 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  public interface IMDLCalculatorBasedOperator : IItem {
+    ILookupParameter<MDLCalculator> MDLCalculatorParameter { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/MDLCalculator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/MDLCalculator.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/MDLCalculator.cs	(revision 9392)
@@ -0,0 +1,143 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  [StorableClass]
+  [Item("MDLCalculator", "")]
+  public class MDLCalculator : Item {
+
+    [Storable]
+    private int activationIteration;
+
+    [Storable]
+    private bool activated;
+    [Storable]
+    private bool fixedWeight;
+
+    [Storable]
+    private double theoryWeight;
+
+    [Storable]
+    private double initialTheoryLengthRatio;
+    [Storable]
+    private double weightRelaxFactor;
+
+    [Storable]
+    private IList<double> accuracyStatistic;
+    [Storable]
+    private int iterationsSinceBest;
+    [Storable]
+    private double bestFitness;
+
+    [Storable]
+    private int weightAdaptionIterations;
+
+    [StorableConstructor]
+    protected MDLCalculator(bool deserializing) : base(deserializing) { }
+    protected MDLCalculator(MDLCalculator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public MDLCalculator(int activationIteration, double initialTheoryLengthRatio, double weightRelaxFactor, int weightAdaptionIterations)
+      : base() {
+      this.activationIteration = activationIteration;
+      this.initialTheoryLengthRatio = initialTheoryLengthRatio;
+      this.weightRelaxFactor = weightRelaxFactor;
+      this.weightAdaptionIterations = weightAdaptionIterations;
+      activated = false;
+      fixedWeight = false;
+      accuracyStatistic = new List<double>();
+      iterationsSinceBest = 0;
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MDLCalculator(this, cloner);
+    }
+
+    public void StartNewIteration(IGAssistSolution bestSolution, int currentIteration) {
+      if (currentIteration == activationIteration) {
+        activated = true;
+        double error = bestSolution.TrainingExceptionsLength;
+        double tl = (bestSolution.TrainingTheoryLength * bestSolution.Classes) / bestSolution.TrainingNumberOfAliveRules;
+        theoryWeight = (initialTheoryLengthRatio / (1.0 - initialTheoryLengthRatio)) * (error / tl);
+        iterationsSinceBest = 0;
+      }
+
+      if (activated && !fixedWeight &&
+        GetLastIterationsAccuracyAverage(weightAdaptionIterations) == 1.0) {
+        fixedWeight = true;
+      }
+
+      if (activated && !fixedWeight) {
+        if (bestSolution.TrainingAccuracy != 1.0) {
+          if (iterationsSinceBest == weightAdaptionIterations) {
+            theoryWeight *= weightRelaxFactor;
+            iterationsSinceBest = 0;
+          }
+        }
+      }
+
+      //if (currentIteration != 0) {
+      UpdateStatistic(bestSolution.TrainingAccuracy);
+      //}
+    }
+
+    private void UpdateStatistic(double accuracy) {
+      if (iterationsSinceBest == 0) {
+        bestFitness = accuracy;
+        iterationsSinceBest++;
+      } else if (accuracy > bestFitness) {
+        bestFitness = accuracy;
+        iterationsSinceBest = 1;
+      } else {
+        iterationsSinceBest++;
+      }
+    }
+
+    private double GetLastIterationsAccuracyAverage(int iterations) {
+      int startAt = accuracyStatistic.Count - iterations;
+      startAt = startAt > 0 ? startAt : 0;
+      return accuracyStatistic.Skip(startAt).Sum() / (accuracyStatistic.Count - startAt);
+    }
+
+    public double CalculateFitness(IGAssistSolution dls) {
+      double fitness = 0;
+      if (activated) {
+        fitness = dls.TrainingTheoryLength * theoryWeight;
+      }
+      fitness += 105.0 - dls.TrainingAccuracy * 100.0;
+      return fitness;
+    }
+
+    public double CalculateFitness(double theoryLength, double accuracy) {
+      double fitness = 0;
+      if (activated) {
+        fitness = theoryLength * theoryWeight;
+      }
+      fitness += 105.0 - accuracy * 100.0;
+      return fitness;
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/MDLIterationOperator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/MDLIterationOperator.cs	(revision 9392)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/GAssist/MDL/MDLIterationOperator.cs	(revision 9392)
@@ -0,0 +1,109 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Optimization.Operators.LCS {
+  [Item("MDLIterationOperator", "Description missing")]
+  [StorableClass]
+  public class MDLIterationOperator : SingleSuccessorOperator {
+
+    #region Parameter Properties
+    public IValueLookupParameter<MDLCalculator> MDLCalculatorParameter {
+      get { return (IValueLookupParameter<MDLCalculator>)Parameters["MDLCalculator"]; }
+    }
+    public ILookupParameter<IntValue> IterationsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["Iterations"]; }
+    }
+    public ILookupParameter<IntValue> MDLActivationIterationParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["MDLActivationIteration"]; }
+    }
+    public ILookupParameter<DoubleValue> InitialTheoryLengthRatioParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["InitialTheoryLengthRatio"]; }
+    }
+    public ILookupParameter<DoubleValue> WeightRelaxFactorParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["WeightRelaxFactor"]; }
+    }
+    public ILookupParameter<IntValue> WeightAdaptionIterationsParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["WeightAdaptionIterations"]; }
+    }
+
+    public ScopeTreeLookupParameter<IGAssistIndividual> IndividualParameter {
+      get { return (ScopeTreeLookupParameter<IGAssistIndividual>)Parameters["Individual"]; }
+    }
+    public LookupParameter<IGAssistNichesProblemData> ProblemDataParameter {
+      get { return (LookupParameter<IGAssistNichesProblemData>)Parameters["ProblemData"]; }
+    }
+    public IScopeTreeLookupParameter<DoubleValue> QualityParameter {
+      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"]; }
+    }
+    public ILookupParameter<BoolValue> MaximizationParameter {
+      get { return (ILookupParameter<BoolValue>)Parameters["Maximization"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected MDLIterationOperator(bool deserializing) : base(deserializing) { }
+    protected MDLIterationOperator(MDLIterationOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public MDLIterationOperator()
+      : base() {
+      Parameters.Add(new LookupParameter<IntValue>("Iterations", ""));
+      Parameters.Add(new ValueLookupParameter<MDLCalculator>("MDLCalculator", ""));
+      Parameters.Add(new LookupParameter<IntValue>("MDLActivationIteration", ""));
+      Parameters.Add(new LookupParameter<DoubleValue>("InitialTheoryLengthRatio", ""));
+      Parameters.Add(new LookupParameter<DoubleValue>("WeightRelaxFactor", ""));
+      Parameters.Add(new LookupParameter<IntValue>("WeightAdaptionIterations", ""));
+
+      Parameters.Add(new ScopeTreeLookupParameter<IGAssistIndividual>("Individual", ""));
+      Parameters.Add(new LookupParameter<IGAssistNichesProblemData>("ProblemData", ""));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The qualities of the trees that should be analyzed."));
+      Parameters.Add(new LookupParameter<BoolValue>("Maximization", "The direction of optimization."));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MDLIterationOperator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (MDLCalculatorParameter.ActualValue == null) {
+        MDLCalculatorParameter.ActualValue = new MDLCalculator(MDLActivationIterationParameter.ActualValue.Value,
+                                                               InitialTheoryLengthRatioParameter.ActualValue.Value,
+                                                               WeightRelaxFactorParameter.ActualValue.Value,
+                                                               WeightAdaptionIterationsParameter.ActualValue.Value);
+      } else {
+        var qualities = QualityParameter.ActualValue;
+        var bestQuality = MaximizationParameter.ActualValue.Value ? qualities.Max() : qualities.Min();
+        int index = qualities.IndexOf(bestQuality);
+        var dls = IndividualParameter.ActualValue[index].CreateGAssistSolution(ProblemDataParameter.ActualValue);
+
+        MDLCalculatorParameter.ActualValue.StartNewIteration(dls, IterationsParameter.ActualValue.Value);
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/HeuristicLab.Optimization.Operators.LCS-3.3.csproj	(revision 9392)
@@ -89,4 +89,5 @@
   <ItemGroup>
     <Compile Include="DefaultRule\AutoDefaultRule.cs" />
+    <Compile Include="Discretizer\InitializeDiscretizersOperator.cs" />
     <Compile Include="GAssist\IGAssistNichesProblemData.cs" />
     <Compile Include="DefaultRule\MajorDefaultRule.cs" />
@@ -98,9 +99,16 @@
     <Compile Include="Discretizer\IDiscretizer.cs" />
     <Compile Include="GAssist\IGAssistProblem.cs" />
+    <Compile Include="GAssist\ILAS\ILASOperator.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistIndividual.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistIndividualCreator.cs" />
+    <Compile Include="GAssist\Interfaces\IGAssistInput.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistNiche.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistNicheEqualityComparer.cs" />
+    <Compile Include="GAssist\Interfaces\IGAssistSolution.cs" />
     <Compile Include="GAssist\Interfaces\IGAssistSpecialStage.cs" />
+    <Compile Include="GAssist\Interfaces\IStrataSingleObjectiveEvaluator.cs" />
+    <Compile Include="GAssist\MDL\IMDLCalculatorBasedOperator.cs" />
+    <Compile Include="GAssist\MDL\MDLCalculator.cs" />
+    <Compile Include="GAssist\MDL\MDLIterationOperator.cs" />
     <Compile Include="GAssist\SpecialStage\GAssistSpecialStageMultiOperator.cs" />
     <Compile Include="GAssist\SpecialStage\GAssistSpecialStageOperator.cs" />
@@ -124,4 +132,8 @@
       <Name>HeuristicLab.Core-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
+      <Project>{df87c13e-a889-46ff-8153-66dcaa8c5674}</Project>
+      <Name>HeuristicLab.Problems.DataAnalysis-3.4</Name>
+    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/NichingTournamentSelector.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/NichingTournamentSelector.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Optimization.Operators.LCS/3.3/Selection/NichingTournamentSelector.cs	(revision 9392)
@@ -88,15 +88,18 @@
 
       int parentsPerChild = ParentsPerChildParameter.ActualValue.Value;
-      var possibleNiches = GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().ToList();
-      var selectPerNiche = new Dictionary<IGAssistNiche, int>(possibleNiches.First().Comparer);
+      var nicheComparer = GAssistNichesProblemDataParameter.ActualValue.GetPossibleNiches().First().Comparer;
+      var selectPerNiche = new Dictionary<IGAssistNiche, int>(nicheComparer);
+      var nicheScope = new Dictionary<IGAssistNiche, List<int>>(nicheComparer);
 
-      var nicheScope = new Dictionary<IGAssistNiche, List<int>>(possibleNiches.First().Comparer);
-      foreach (var niche in possibleNiches) {
-        nicheScope.Add(niche, new List<int>());
-        selectPerNiche.Add(niche, count / possibleNiches.Count);
+      for (int i = 0; i < individuals.Count; i++) {
+        if (!nicheScope.ContainsKey(individuals[i].Niche)) {
+          nicheScope.Add(individuals[i].Niche, new List<int>());
+        }
+        nicheScope[individuals[i].Niche].Add(i);
       }
 
-      for (int i = 0; i < individuals.Count; i++) {
-        nicheScope[individuals[i].Niche].Add(i);
+      var possibleNiches = nicheScope.Keys.ToList();
+      foreach (var niche in possibleNiches) {
+        selectPerNiche.Add(niche, count / possibleNiches.Count);
       }
 
@@ -144,11 +147,11 @@
     }
 
-    private IGAssistNiche GetNiche(IRandom random, Dictionary<IGAssistNiche, int> nicheScope, List<IGAssistNiche> possibleNiches) {
-      int sum = nicheScope.Values.Sum();
+    private IGAssistNiche GetNiche(IRandom random, Dictionary<IGAssistNiche, int> selectPerNiche, List<IGAssistNiche> possibleNiches) {
+      int sum = selectPerNiche.Values.Sum();
       if (sum <= 0) { return possibleNiches[random.Next(possibleNiches.Count)]; }
       int pos = random.Next(sum);
       int total = 0;
-      IGAssistNiche niche = nicheScope.Keys.First();
-      foreach (var item in nicheScope) {
+      IGAssistNiche niche = selectPerNiche.Keys.First();
+      foreach (var item in selectPerNiche) {
         total += item.Value;
         niche = item.Key;
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/ConditionActionClassificationProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/ConditionActionClassificationProblemData.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.ConditionActionClassification/3.3/ConditionActionClassificationProblemData.cs	(revision 9392)
@@ -126,10 +126,5 @@
       if (allowedConditionVariables == null) throw new ArgumentNullException("The allowedActionVariables must not be null.");
 
-      if (allowedActionVariables.Except(dataset.DoubleVariables).Any())
-        throw new ArgumentException("All allowed action variables must be present in the dataset and of type double.");
-      if (allowedConditionVariables.Except(dataset.DoubleVariables).Any())
-        throw new ArgumentException("All allowed condition variables must be present in the dataset and of type double.");
-
-      var actionVariables = new CheckedItemList<StringValue>(dataset.DoubleVariables.Select(x => new StringValue(x)));
+      var actionVariables = new CheckedItemList<StringValue>(dataset.VariableNames.Select(x => new StringValue(x)));
       var conditionVariables = new CheckedItemList<StringValue>(actionVariables);
       foreach (StringValue x in actionVariables) {
Index: /branches/LearningClassifierSystems/HeuristicLab.Problems.DecisionListClassification/3.3/DecisionListClassificationProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Problems.DecisionListClassification/3.3/DecisionListClassificationProblem.cs	(revision 9391)
+++ /branches/LearningClassifierSystems/HeuristicLab.Problems.DecisionListClassification/3.3/DecisionListClassificationProblem.cs	(revision 9392)
@@ -62,7 +62,4 @@
       get { return (IFixedValueParameter<IntValue>)Parameters["SizePenaltyMinRules"]; }
     }
-    public IFixedValueParameter<IntValue> ActivationIterationParameter {
-      get { return (IFixedValueParameter<IntValue>)Parameters["ActivationIteration"]; }
-    }
     public IFixedValueParameter<DoubleValue> InitialTheoryLengthRatioParameter {
       get { return (IFixedValueParameter<DoubleValue>)Parameters["InitialTheoryLengthRatio"]; }
@@ -88,4 +85,7 @@
     }
 
+    IStrataSingleObjectiveEvaluator IGAssistProblem.Evaluator {
+      get { return Evaluator; }
+    }
     IDecisionListEvaluator IDecisionListClassificationProblem.Evaluator {
       get { return Evaluator; }
@@ -101,4 +101,7 @@
       : base(original, cloner) {
     }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new DecisionListClassificationProblem(this, cloner);
+    }
 
     public DecisionListClassificationProblem()
@@ -113,12 +116,7 @@
       Parameters.Add(new FixedValueParameter<DoubleValue>("BestKnownQuality", "", new DoubleValue(0.5)));
       Parameters.Add(new FixedValueParameter<IntValue>("SizePenaltyMinRules", "", new IntValue(4)));
-      Parameters.Add(new FixedValueParameter<IntValue>("ActivationIteration", "", new IntValue(25)));
-      Parameters.Add(new FixedValueParameter<DoubleValue>("InitialTheoryLengthRatio", "", new DoubleValue(0.075)));
-      Parameters.Add(new FixedValueParameter<DoubleValue>("WeightRelaxFactor", "", new DoubleValue(0.9)));
       Parameters.Add(new FixedValueParameter<PercentValue>("ActionMutationProbability", "", new PercentValue(0.1)));
 
       Evaluator.SizePenaltyMinRulesParameter.ActualName = "SizePenaltyMinRules";
-      // do differently
-      ((MDLEvaluator)Evaluator).MDLCalculatorParameter.Value = new MDLCalculator(ActivationIterationParameter.Value.Value, InitialTheoryLengthRatioParameter.Value.Value, WeightRelaxFactorParameter.Value.Value);
 
       InitializeOperators();
@@ -169,7 +167,4 @@
       }
     }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new DecisionListClassificationProblem(this, cloner);
-    }
 
     IParameter IGAssistProblem.ProblemDataParameter {
